/*
 * plugin_api.h
 * Copyright 2005 Linuon Inc. Tokyo Japan All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *     Junji Kanemaru <junji.kanemaru@linuon.com>
 */
#ifndef PLUGIN_API_H
#define PLUGIN_API_H
#include "event.h"

typedef enum {
    PLUGIN_TYPE_INPUT,
    PLUGIN_TYPE_FILTER,
    PLUGIN_TYPE_OUTPUT
} PluginType;


typedef const char* (*PLUGIN_API_getPluginName)(void);
typedef PluginType (*PLUGIN_API_getPluginType)(void);
typedef int (*PLUGIN_API_init)(const char* config);
typedef int (*PLUGIN_API_eventHandler)(Event& evt);

typedef struct {
    PLUGIN_API_getPluginName getPluginName;
    PLUGIN_API_getPluginType getPluginType;
    PLUGIN_API_init init;
    PLUGIN_API_eventHandler eventHandler;
} PluginInterface;

/**
** Shared library entry */
#define PLUGIN_ENTRY_SYMBIL_NAME    "__PluginEntry"
typedef const PluginInterface* (*__PluginEntry)(void);

#endif /* PLUGIN_API_H */

